﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MvcMovie.Models.ESignManagment
{
    public static class EsignData
    {
        public static List<SignerInformation> GetSignerRepository()
        {

            var Signer1 = new SignerInformation()
            {
                SignerIndex = 0,
                SignerName = "Joe Dewo",
                SignatureStatus = true,
                eSign = SignerInformation.eSignature.InPerson,
                SignerAuth = new SignerAuthentication { AuthenticationMode = SignerAuthentication.AuthenticationType.Email,EmailAddress = "test@immonline.com" ,Details     = "Signer1 Details"}
            };

            var Signer2 = new SignerInformation()
            {
                SignerIndex = 1,
                SignerName = "Rob",
                SignatureStatus = false,
                eSign = SignerInformation.eSignature.Remote,
                SignerAuth = new SignerAuthentication
                     {
                         AuthenticationMode = SignerAuthentication.AuthenticationType.KBA,
                         EmailAddress = "tes2t@immonline.com",
                         Details = "Signer2 Details"
                     }
            };
            var Signer3 = new SignerInformation()
            {
                SignerIndex = 2,
                SignerName = "John Wattson",
                SignatureStatus = false,
                eSign = SignerInformation.eSignature.InPerson,
                SignerAuth = new SignerAuthentication { AuthenticationMode = SignerAuthentication.AuthenticationType.Password,EmailAddress = "test1@immonline.com",Details = "Signer3 Details" }
            };
            var SignersInfoCol = new List<SignerInformation>();
            SignersInfoCol.Add(Signer1);
            SignersInfoCol.Add(Signer2);
            SignersInfoCol.Add(Signer3);
            return SignersInfoCol;
        }

        public static List<SessionDocument> GetDocumentsRepository()
        {
            var doc1 = new SessionDocument()
            {
                DocumentIndex = 1,
                DocumentName = "Loaner",
                SignerIndex = 0,
                PdfUrl = @"/MvcMovie/SourcePDFs/XP_Insurance_IMM!.pdf",
              
            };
            var doc2 = new SessionDocument()
            {
                DocumentIndex = 2,
                DocumentName = "Attachment",
                SignerIndex = 0,
                PdfUrl = @"/MvcMovie/SourcePDFs/Application_AXX026_IMM!.pdf",
               
            };

            var doc3 = new SessionDocument()
            {
                DocumentIndex = 3,
                DocumentName = "Mortgage",
                SignerIndex = 1,
                PdfUrl = @"/MvcMovie/SourcePDFs/Application_with_CC_AXX127.pdf",
               
            };

            var sessionDocs = new List<SessionDocument>();
            sessionDocs.Add(doc1);
            sessionDocs.Add(doc2);
            sessionDocs.Add(doc3);
            return sessionDocs;
        }

        public static bool BindSignerStatus(int signerIndex)
        {
            var SignersInfoCol = GetSignerRepository();
            var x = SignersInfoCol.Find(y => y.SignerIndex.Equals(signerIndex));
            return (x.SignatureStatus);            
        }

        public static List<AuthType> GetAuthenticationTypes()
        {
            var listAutType = new List<AuthType>();
            AuthType autType = new AuthType
            {
                id = "0",
                Type = "Email"
            };
            AuthType autType1 = new AuthType
            {
                id = "1",
                Type = "Password"
            };
            AuthType autType2 = new AuthType
            {
                id = "2",
                Type = "KBA"
            };
            listAutType.Add(autType);
            listAutType.Add(autType1);
            listAutType.Add(autType2);
            return listAutType;
        }
    }

    public class AuthType{
        public string Type {set; get;}
        public string id { set; get; }
       

      
    }
}